#Compile Exe
#Register None
#Dim All
#Include "Win32Api.Inc"
#Include "Loader.bas"
#Include "Zlib_Dll.bas"


   Global g_gzLastError As String
    %DECOMPRESS_BLOCK_SIZE     = 100000

    $Z_OPEN_READ               = "rb"
    $Z_OPEN_WRITE              = "wb"
    %Z_NO_FLUSH                = 0
    %Z_PARTIAL_FLUSH           = 1
    %Z_SYNC_FLUSH              = 2
    %Z_FULL_FLUSH              = 3
    %Z_FINISH                  = 4
    %Z_OK                      = 0
    %Z_STREAM_END              = 1
    %Z_NEED_DICT               = 2
    %Z_ERRNO                   = -1
    %Z_STREAM_ERROR            = -2
    %Z_DATA_ERROR              = -3
    %Z_MEM_ERROR               = -4
    %Z_BUF_ERROR               = -5
    %Z_VERSION_ERROR           = -6
    %Z_NO_COMPRESSION          = 0
    %Z_BEST_SPEED              = 1
    %Z_BEST_COMPRESSION        = 9
    %Z_DEFAULT_COMPRESSION     = -1
    %Z_FILTERED                = 1
    %Z_HUFFMAN_ONLY            = 2
    %Z_DEFAULT_STRATEGY        = 0
    %Z_BINARY                  = 0
    %Z_ASCII                   = 1
    %Z_UNKNOWN                 = 2
    %Z_DEFLATED                = 8


  Declare Function gzopen    (zFile As Asciiz, zMode As Asciiz ) As Long
  Declare Function gzwrite   (ByVal file As Long, uncompr As Any, ByVal uncomprLen As Long) As Long
  Declare Function gzclose   (ByVal file As Long ) As Long

  Function gzCompressFile(inFile As String, outFile As String) As Long
      Dim f                As Local Dword
      Dim j                As Local Long
      Dim ZLIB_hDll        As Local Dword
      Dim ZLIB_gzopen   As Local Dword
      Dim ZLIB_gzwrite  As Local Dword
      Dim ZLIB_gzclose As Local Dword
      Dim szRawDll         As Local String
      Dim szBufO           As Local String
      Dim szBufC           As Local String
      Dim szBufU           As Local String
      szRawDll=Zlib
      If LoadDllFromMemory (StrPtr(szRawDll), Len(szRawDll), ZLIB_hDll) Then Beep: Exit Function ' errors
      szRawDll = ""
      ZLIB_gzopen  = GetProcAddressDirectly (ZLIB_hDll, "gzopen")
      ZLIB_gzwrite  = GetProcAddressDirectly (ZLIB_hDll, "gzwrite")
      ZLIB_gzclose = GetProcAddressDirectly (ZLIB_hDll, "gzclose")
      Dim hInput As Long
      Dim hOutput As Long
      Dim iReturn As Long
      Dim i As Long
      Dim iBlocks As Long
      Dim iLeft As Long
      Dim sInput As String

      g_gzLastError = "Success"

      If Dir$(inFile) = "" Then
          g_gzLastError = "Input file " + inFile + " not found"
          GoTo gzCompresssFile_Error
       End If

       If Dir$(outFile) <> "" Then
          g_gzLastError = "Output file: " + outFile + " already exists"
          GoTo gzCompresssFile_Error
       End If

      Call Dword ZLIB_gzopen Using gzopen (ByCopy outFile, $Z_OPEN_WRITE)   To hOutput

   If hOutput = 0 Then
      g_gzLastError = "zLib is unable to open output file: " + outFile
      GoTo gzCompresssFile_Error
   End If

   On Error Resume Next
   hInput = FreeFile
   Open inFile For Binary Shared As #hInput
   If Err Then
      hInput = 0
      g_gzLastError = "Unable to open input file: " + inFile + " Error =" + Str$(Err)
      GoTo gzCompresssFile_Error
   ElseIf Lof(hInput) < 1 Then
      g_gzLastError = "Input file: " + inFile + " is zero-length"
      GoTo gzCompresssFile_Error
   End If

   #If 0
   On Error Resume Next
   sInput = String$(Lof(hInput), 0)
   If Err Then
      g_gzLastError = "Error allocating " + Format$(Lof(hInput)) + " bytes of memory"
      GoTo gzCompresssFile_Error
   End If

   Get #hInput,, sInput
   If Err Then
      g_gzLastError = "Error reading from: " + inFile + " Error =" + Str$(Err)
      GoTo gzCompresssFile_Error
   End If
    iReturn = gzwrite(hOutput, ByVal StrPtr(sInput), Len(sInput))
   If iReturn <> Len(sInput) Then
      g_gzLastError= "Error compressing data buffer: " + Format$(iReturn)
      GoTo gzCompresssFile_Error
   End If
   #EndIf

   iLeft =  Lof(hInput) Mod %DECOMPRESS_BLOCK_SIZE
   iBlocks = (Lof(hInput) - iLeft) / %DECOMPRESS_BLOCK_SIZE
   sInput = Space$(%DECOMPRESS_BLOCK_SIZE)
   If Err Then
      g_gzLastError = "Error allocating " + Format$(%DECOMPRESS_BLOCK_SIZE) + " bytes of memory"
      GoTo gzCompresssFile_Error
   End If

   For i = 1 To iBlocks
      Get #hInput,, sInput
      If Err Then
         g_gzLastError = "Error reading from: " + inFile + " Error =" + Str$(Err)
         GoTo gzCompresssFile_Error
      End If
      Call Dword ZLIB_gzwrite Using gzwrite (hOutput, ByVal StrPtr(sInput), Len(sInput))    To iReturn
      If iReturn <> Len(sInput) Then
         g_gzLastError= "Error compressing data buffer: " + Format$(iReturn)
         GoTo gzCompresssFile_Error
      End If
   Next i

   If iLeft > 0 Then
      sInput = Space$(iLeft)
      If Err Then
         g_gzLastError = "Error allocating " + Format$(iLeft) + " bytes of memory"
         GoTo gzCompresssFile_Error
      End If

      Get #hInput,, sInput
      If Err Then
         g_gzLastError = "Error reading from: " + inFile + " Error =" + Str$(Err)
         GoTo gzCompresssFile_Error
      End If
       Call Dword ZLIB_gzwrite Using gzwrite (hOutput, ByVal StrPtr(sInput), Len(sInput))    To iReturn
      If iReturn <> Len(sInput) Then
         g_gzLastError= "Error compressing data buffer: " + Format$(iReturn)
         GoTo gzCompresssFile_Error
      End If
   End If
   Close #hInput
   Call Dword ZLIB_gzclose Using gzclose (hOutput)
   Function = %True
   Exit Function

  gzCompresssFile_Error:

End Function

Function PBMain
     gzCompressFile "zlib_dll.bas", "zlib_dll.zip"
End Function
